;ore 23:20
; Dato il vettore di interi vett1 = { 10,2,5,8,6,4,9,16,3,46} 
; si realizzi un programma in assembly  che:
; (a) Crea due vettori vett2 e vett3 contenenti rispettivamente la prima met e
; la seconda met di vett1 (ossia i primi 5 di vett1 vanno in vett2, gli ultimi 5
; di vett1 vanno in vett3.)
; (b) Crea un vettore vett4 tale che: vett4[i] = 1 se vett2[i]>vett3[i] , 0 altrimenti
; (c) scrivere in R30 la somma delle radici dei quadratti perfetti di vett2 e vett3
;
; by Massimo Trubia (max83t)
		.data
vett1: .word 10,2,5,8,6,4,9,16,3,46
vett2: .word 0,0,0,0,0
vett3: .word 0,0,0,0,0
vett4: .word 0,0,0,0,0
		.text
		daddi r1,r0,vett2
		daddi r2,r0,vett3
		dsub r3,r2,r1		;r3=size_ridotta
		daddi r1,r0,0		;r1=i=0
while_scanvett1:
		slt r2,r1,r3				;while(i<size_ridotta)
		beqz r2,endwhile_scanvett1
		ld r4,vett1(r1)		;r4=vett1[i]
		sd r4,vett2(r1)		;vett2[i]=vett1[i];
		daddi r6,r1,40
		ld r5,vett1(r6)
		sd r5,vett3(r1)		;vett3[i]=vett1[i+5];  5==40
		slt r6,r5,r4			;if(vett2[i]>vett3[i])
		beqz r6,nomaggiore
maggiore: 	daddi r7,r0,1
		sd r7,vett4(r1)		;vett4[i]=1;
		j incr
nomaggiore: sd r0,vett4(r1)		;vett4[i]=0;
incr:		daddi r1,r1,8
		j while_scanvett1
endwhile_scanvett1: daddi r1,r0,0  ;r1=i=0
		daddi r10,r0,0		;r10=s=sommatore=0
while_sommaradici: slt r2,r1,r3
		beqz r2,endwhile_sommaradici
		ld r30,vett2(r1)		;r29=rad=sqrt(vett2[i]);
		jal sqrt
		beqz r29,nonesisteradice
		dadd r10,r10,r29
nonesisteradice: ld r30,vett3(r1)
		jal sqrt
		beqz r29,nonesisteradice2
		dadd r10,r10,r29
nonesisteradice2: daddi r1,r1,8		
		j while_sommaradici
endwhile_sommaradici:

HALT
;*************FUNZIONE RADICE ***************
;  sqrt(int val)       r30=val      r29=radice opp. 0
sqrt:		daddi r20,r0,1		;r20=i=1
while_trovaquad:
		DMUL r20,r20		;r19=quad=i*i
		MFLO r19
		slt r18,r30,r19		;while((quad=i*i)<=val)
		bnez r18,endwhile_trovaquad
		bne r19,r30,incr2			;if(quad==val)
		dadd r29,r0,r20			;return i;
		jr r31
incr2:	daddi r20,r20,1	
		j while_trovaquad
endwhile_trovaquad: daddi r29,r0,0
		jr r31				;return 0;
		
